from pathlib import PosixPath
from typing import Any, Dict, Optional, Sequence, Tuple, Union

__all__ = [
    'Types',
    'SYSTEMD_SERVICE_CONFIG',
    'SYSTEMD_NETWORK_CONFIG',
    'SYSTEMD_CONFIG_ROOT',
    'systemdbool',
    'AnsibleParameter',
]

SYSTEMD_CONFIG_ROOT: PosixPath
SYSTEMD_NETWORK_CONFIG: PosixPath
SYSTEMD_SERVICE_CONFIG: PosixPath
AnsibleParameter = dict[str, Any]

class meta(type):
    def __new__(cls, clsname, bases, attrs): ...

class Types(metaclass=meta):
    @staticmethod
    def str(
        required: bool = False,
        help: str | list[str] | None = None,
        choices: Optional[Sequence] = None,
        default: Optional[Any] = None,
    ): ...
    @staticmethod
    def bool(
        required: bool = False,
        help: str | list[str] | None = None,
        choices: Optional[Sequence] = None,
        default: Optional[Any] = None,
    ): ...
    @staticmethod
    def int(
        required: bool = False,
        help: str | list[str] | None = None,
        choices: Optional[Sequence] = None,
        default: Optional[Any] = None,
    ): ...
    @staticmethod
    def float(
        required: bool = False,
        help: str | list[str] | None = None,
        choices: Optional[Sequence] = None,
        default: Optional[Any] = None,
    ): ...
    @staticmethod
    def path(
        required: bool = False,
        help: str | list[str] | None = None,
        choices: Optional[Sequence] = None,
        default: Optional[Any] = None,
    ): ...
    @staticmethod
    def raw(
        required: bool = False,
        help: str | list[str] | None = None,
        choices: Optional[Sequence] = None,
        default: Optional[Any] = None,
    ): ...
    @staticmethod
    def jsonarg(
        required: bool = False,
        help: str | list[str] | None = None,
        choices: Optional[Sequence] = None,
        default: Optional[Any] = None,
    ): ...
    @staticmethod
    def json(
        required: bool = False,
        help: str | list[str] | None = None,
        choices: Optional[Sequence] = None,
        default: Optional[Any] = None,
    ): ...
    @staticmethod
    def bytes(
        required: bool = False,
        help: str | list[str] | None = None,
        choices: Optional[Sequence] = None,
        default: Optional[Any] = None,
    ): ...
    @staticmethod
    def bits(
        required: bool = False,
        help: str | list[str] | None = None,
        choices: Optional[Sequence] = None,
        default: Optional[Any] = None,
    ): ...
    @staticmethod
    def list(
        elements: type[object] | str | AnsibleParameter,
        required: bool = False,
        help: str | list[str] | None = None,
        default: list[Any] | None = None,
    ) -> AnsibleParameter: ...
    @staticmethod
    def dict(
        required: bool = False, help: str | list[str] | None = None, **options: AnsibleParameter
    ) -> AnsibleParameter: ...

def systemdbool(b: bool | str) -> str: ...
def joindict(*items: dict) -> dict: ...
def modspec(
    argument_spec: Dict[str, Dict[str, Any]],
    mutually_exclusive: Sequence[Tuple[str, ...]] = (),
    required_together: Sequence[Tuple[str, ...]] = (),
    required_one_of: Sequence[Tuple[str, ...]] = (),
    required_if: Sequence[Union[Tuple[str, Any, Tuple[str, ...]], Tuple[str, Any, Tuple[str, ...], bool]]] = (),
    required_by: Dict[str, Union[str, Tuple[str, ...]]] = {},
    supports_check_mode: bool = False,
    add_file_common_args: bool = False,
) -> Dict[str, Any]: ...
